part of example;

class Navigationbar {
  
  Sandbox _sandbox;
  Element _contentEl;
  
  init (Sandbox sandbox) {
		_sandbox = sandbox;
  }
  
  start(Map options) {
    var html = ['<form id="module-navigationbar" class="navbar-form pull-right">',
                  '<input type="text" placeholder="search in todos..." class="input-medium search-query">',
                  '<button type="submit" class="btn btn-small">Search</button>',
                '</form>'].join('');
    _contentEl = new Element.html(html);
    options['containerEl'].query('.container').append(_contentEl);
    
    this.setupSearchForm();
  }
  
  stop() {
    _contentEl.remove();
  }
  
  setupSearchForm() {
    var iptSearch = _contentEl.querySelector('input');
    var btnSubmit = _contentEl.querySelector('button');
    
    btnSubmit.onClick.listen((MouseEvent event) {
      event.preventDefault();
      
      _sandbox.mediator('navigationbar', 'search').add(iptSearch.value);
      iptSearch.value = '';
    });
    
    iptSearch.onKeyDown.listen((event) {
      if (iptSearch.value.length > 1) {
        var cache = iptSearch.value;
        
        if (event.keyCode == KeyCode.ENTER) {
          event.preventDefault();
          iptSearch.value = '';
        }
        
        _sandbox.mediator('navigationbar', 'filter').add(cache);
      }
      else {
        _sandbox.mediator('navigationbar', 'clearfilter').add(null);
      }
    });
  }
}